Imports System
Imports System.Data
Imports System.Data.SqlClient

namespace HowTo.ADONET24.Samples

public class ADOErrors
  public shared sub Main()
    Dim myADOErrors as ADOErrors
    myADOErrors = new ADOErrors()
    myADOErrors.Run()
  end sub

  public sub Run()
    ' Create a new Connection and SqlDataAdapter
    Dim myConnection as SqlConnection
    Dim mySqlDataAdapter as SqlDataAdapter
    myConnection = new SqlConnection("server=localhost;Trusted_Connection=yes;database=northwind")
    mySqlDataAdapter = new SqlDataAdapter("select * from customers", myConnection)
    Dim CustomerDS as DataSet
    CustomerDS = new DataSet()
    try
      mySqlDataAdapter.Fill(CustomerDS,"Customers")
      Dim CustomerView as DataView
      CustomerView = new DataView(CustomerDS.Tables("Customers"))
      CustomerView.Sort = "CustomerID"

      CustomerDS.Tables("Customers").Rows(0).RowError = "Invalid Customer Row - Error"

      if CustomerDS.Tables("Customers").HasErrors then
        Dim ErrDataRows as DataRow()
        ErrDataRows = CustomerDS.Tables("Customers").GetErrors()
        Console.WriteLine("DataTable {0} has {1} Error(s)",CustomerDS.Tables("Customers").TableName,ErrDataRows.Length.ToString())
        Dim i as integer
        for i = 0 to ErrDataRows.Length -1
          Console.WriteLine("Row Error for {0} ** {1}",ErrDataRows(i)("CompanyName").ToString(),ErrDataRows(i).RowError)
        next
      else
        Console.WriteLine("DataTable {0} Has no errors", CustomerDS.Tables("Customers").TableName)
      end if
    catch e as Exception
      Console.WriteLine(e.ToString())
    end try
  end sub
end class

end namespace