Imports System
Imports System.Data
Imports System.Data.SqlClient

namespace HowTo.Samples.ADONET

public class readandwritexml
  public shared sub Main()
    Dim myreadandwritexml as readandwritexml
    myreadandwritexml = new readandwritexml()
    myreadandwritexml.Run()
  end sub

  public sub Run()
    try
      Dim myConnection as SqlConnection
      Dim mySqlDataAdapter1 as SqlDataAdapter
      Dim mySqlDataAdapter2 as SqlDataAdapter
      Dim myDataSet as DataSet

      myConnection = new SqlConnection("server=C81124-E\DBARCH01;Trusted_Connection=yes;database=northwind")
      mySqlDataAdapter1 = new SqlDataAdapter("select * from customers", myConnection)
      mySqlDataAdapter2 = new SqlDataAdapter("select * from orders", myConnection)

      myDataSet = new DataSet()

      mySqlDataAdapter1.Fill(myDataSet,"Customers")
      mySqlDataAdapter2.Fill(myDataSet,"Orders")

      Dim xmlsample As System.IO.StreamWriter = New System.IO.StreamWriter("Customers.xml")
      myDataSet.WriteXml(xmlsample, XmlWriteMode.DiffGram)
      xmlsample.Close()

      Dim strXMLData as String
      Dim strXMLSchema as String

      strXMLData = myDataSet.GetXml()
      strXMLSchema = myDataSet.GetXmlSchema()

      Console.WriteLine("Select View Source to see XMLSchema")
      Console.WriteLine(strXMLSchema)
      Console.WriteLine("")
      Console.WriteLine("Data")
      Console.WriteLine(strXMLData)
    catch e as Exception
      Console.WriteLine(e.ToString())
    end try
  end sub
end class

end namespace

