<% @Page Debug="true" Language="VB" aspcompat="true" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="ADO24HRS.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
                  
            LoadDataGrid(orders)
                   
        End Sub
                  
        Private Sub LoadDataGrid( _
                         myDataGrid as System.Web.UI.WebControls.DataGrid)
                  
            'Create Instance of Legacy Object
            Dim adoComponent as Object = Server.CreateObject("Northwind.DataAccess")
            
            'Create Instance of Legacy Recordset
            Dim adoRS As ADODB._Recordset 
            
            'Access Legacy Method that returns recordset
            adoRS = adoComponent.GetAllEmployees()

            'Create ADO.NET objects
            Dim adapter As OleDbDataAdapter = New OleDbDataAdapter
            Dim dsEmployees As DataSet = New DataSet

            'Use overloaded Fill() method to place recordset contents into
            'a DataTable in the dsEmployees Dataset
            adapter.Fill(dsEmployees, adoRS, "Employees")

            'Bind!
            orders.DataSource = dsEmployees
            orders.DataBind()
                    
        End Sub
	</script>
	
</HEAD>
<BODY>

<h1 class="MainHeader">Northwind Employees</h1>
<hr>

<form runat="server" id=form1 name=form1>
   <asp:DataGrid id="orders" runat="server"></asp:DataGrid>
</form>
<hr>

</BODY>
</HTML>
