<%@ Page Debug="true" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
          
          If IsPostBack then
          
            Dim sOutput as string
            
            'Create Connection
            Dim conn as SqlConnection = new SqlConnection("Data Source=" + _
                            "localhost;Initial Catalog=northwind;UID=sa;PWD=;")
                                        
            'Create Command
            Dim cmd as SqlCommand = new SqlCommand()
            cmd.Connection = conn
            
            'Connection must be open to start transaction
            conn.Open()
            
            'Create Transaction and apply it to command object
            Dim myTrans = conn.BeginTransaction("TransactionName")
            cmd.Transaction = myTrans

            'Show Database before modifications
            GetAndBindData(datagrid1)
            
            'Execute Database Change #1
            ExecuteSQL(cmd, "UPDATE Fruits SET Quantity = 4 " + _
                            "WHERE Name = 'Apple'")
            
            'Insert hundreds of database changes here            
            
            'Save Transaction
            myTrans.Save("SavePoint1")
            
            'Execute Database Change #2
            'ExecuteSQL(cmd, "DELETE FROM FRUITS")

            'Oh no!  We've made a horrible mistake.
            'Rollback to saved point
            myTrans.Rollback("SavePoint1")

            'Commit earlier changes
            myTrans.Commit()

            'Requery
            GetAndBindData(datagrid7)
            
            conn.Close()
          
          Else
            
            '--- No post back --- 
            'Just display the fruit table as it is
            GetAndBindData(datagrid1)
                        
          End If  'Postback                  
            
        End Sub
        
        Private Sub ExecuteSQL(cmd as SqlCommand, sSQL as string)
        
            cmd.CommandText = sSQL
            cmd.ExecuteNonQuery()
        
        End Sub
        
        Private Sub GetAndBindData( myDataGrid as _
                                        System.Web.UI.WebControls.DataGrid )
            
            Dim conn as SqlConnection = new SqlConnection("Data Source=" + _
                           "localhost;Initial Catalog=Northwind;UID=sa;PWD=;")
            Dim cmd as SqlCommand = new SqlCommand("SELECT name, " + _
                                    "description, quantity FROM Fruits", conn)
   
            conn.Open()
            myDataGrid.DataSource = cmd.ExecuteReader()
            myDataGrid.DataBind()
            conn.Close()
               
        End Sub               
	</script>
	
</HEAD>
<BODY>

<h1>Working With Transactions</h1>
<hr>



<form runat="server" id=form1 name=form1>
  <asp:label id=lblStatus runat="server" />

  <p>

  <input type="submit" Value="Run Queries" id=submit1 name=submit1>
  <table align="center" cellpadding=10 cellspacing=10>
    <tr>
      <td colspan=2 valign="center">
        <h3>Original Data:</h3>
        <asp:datagrid id=datagrid1 runat="server" />
        <br><br>
      </td>
    </tr>
    </tr>
      <td colspan=2>
        <h3>After rolling back transaction to saved point:</h3>
        <asp:datagrid id=datagrid7 runat="server" />
      </td>      
    </tr>
  </table> 
  
</form>
<hr>

</BODY>
</HTML>
