CREATE PROCEDURE Product_Add 
(
	@ProductName nvarchar(40),
	@QuantityPerUnit nvarchar(20),
	@UnitPrice money,
	@UnitsInStock smallint,
	@ImagePath varchar(256),
	@Discontinued bit,
	@ProductID int OUTPUT
)
AS

INSERT INTO Products
(
	ProductName,
	QuantityPerUnit,
	UnitPrice,
	UnitsInStock,
	ImagePath,
	Discontinued
)
VALUES
(
	@ProductName,
	@QuantityPerUnit,
	@UnitPrice,
	@UnitsInStock,
	@ImagePath,
	@Discontinued
)

SELECT @ProductID = @@IDENTITY
