public sub GetCategoryData()

  'if the dataset exists in the cache
  if Page.Cache("Categories") <> "" then
     'Return the cached DataSet
     return Ctype(Page.Cache("Categories"), DataSet)
  'otherwise, retrieve DataSet from database
  else 
     'Create ADO.NET connection and command objects
     SqlConnection conn = new SqlConnection( _
         ConfigurationSettings.AppSettings("ConnectionString"))
     SqlCommand cmd = new SqlCommand("SELECT * " + _
                                          "FROM Categories", conn)

     'Create DataAdapter and DataSet objects
     Dim myAdapter as SqlDataAdapter = new SqlDataAdapter(cmd)
     Dim ds as DataSet = new DataSet()
			  				
     'Open connection to database
     conn.Open()

     'Fill the DataSet
     myAdapter.Fill(ds, "Categories")

     'Close connection to database
     conn.Close()

     'Place the dataset in the cache
     context.Cache("AllDomains") = ds

     'Return the dataset
     Return ds

end sub
