<% @Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
                  
            LoadDataGrid(orders)
                   
        End Sub
                  
        Private Sub LoadDataGrid( _
                         myDataGrid as System.Web.UI.WebControls.DataGrid)
                  
           Dim conn as New SqlConnection("Initial Catalog=Northwind;" + _
                                       "Server=(local);UID=sa;PWD=;")
           Dim cmd as New SqlCommand("SELECT OrderID, " + _
                                     "CustomerID, " + _
                                     "OrderDate, " + _
                                     "ShipName " + _
                                     "FROM Orders", conn)
                     
           conn.Open()
           myDataGrid.DataSource = cmd.ExecuteReader()        
           myDataGrid.DataBind()  
           conn.Close()    
                    
        End Sub
	</script>
	
</HEAD>
<BODY>

<h1>Order Administration - List</h1>
<hr>

<form runat="server">
    <asp:DataGrid id="orders" width="90%" 
                  GridLines="Vertical" cellpadding="4" cellspacing="0" 
                  Font-Name="Verdana" Font-Size="8pt" ShowFooter="true" 
                  BorderColor="SaddleBrown" BackColor="PapayaWhip"
                  AutoGenerateColumns="false" runat="server">
        <Columns>
            <asp:BoundColumn HeaderText="Order ID" DataField="OrderID" />
            <asp:BoundColumn HeaderText="Customer ID" DataField="CustomerID" />
            <asp:BoundColumn HeaderText="ShipTo Name" DataField="ShipName" />
            <asp:BoundColumn HeaderText="Order Date" DataField="OrderDate" DataFormatString="{0:d}" />
            <asp:HyperLinkColumn Text="Show Order Details" 
                   DataNavigateUrlField="OrderID" 
                   DataNavigateUrlFormatString="orderdetails.aspx?OrderID={0}" />
        </Columns>
    </asp:DataGrid>
</form>
<hr>

</BODY>
</HTML>
