<% @Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
                  
            'Get OrderID
            Dim OrderID As Integer = Int32.Parse(Request.Params("OrderID"))

            LoadGridData( OrderID, orderdetails )

        End Sub
                  
        Private Sub LoadGridData( orderID as Int32, _
                            myDataGrid as System.Web.UI.WebControls.DataGrid )
                  
           Dim conn as New SqlConnection("Initial Catalog=Northwind;" + _
                                       "Server=(local);UID=sa;PWD=;")
           Dim cmd as New SqlCommand("Exec Order_GetDetails " + orderID.ToString(), conn)
    
           conn.Open()
           myDataGrid.DataSource = cmd.ExecuteReader()
           myDataGrid.DataBind()
           conn.Close()                 
                    
        End Sub
	</script>
	
</HEAD>
<BODY>

<h1>Order Administration - Details</h1>
<hr>

<form runat="server">

    <asp:DataGrid id="orderdetails" width="90%" BorderColor="SaddleBrown" 
                  BackColor="PapayaWhip" GridLines="Vertical" cellpadding="4" 
                  cellspacing="0" Font-Name="Verdana" Font-Size="8pt" 
                  ShowFooter="true" AutoGenerateColumns="false" 
                  runat="server">
        <Columns>
          <asp:BoundColumn HeaderText="Order ID" DataField="OrderID" />
          <asp:BoundColumn HeaderText="Product Name" DataField="ProductName" />
          <asp:BoundColumn HeaderText="Unit Price" DataField="UnitPrice" 
                  DataFormatString="{0:c}" />
          <asp:BoundColumn HeaderText="Quantity" DataField="Quantity" />
          <asp:BoundColumn HeaderText="Discount Received" DataField="Discount" />
        </Columns>
    </asp:DataGrid>

</form>
<hr>

</BODY>
</HTML>
