CREATE PROCEDURE Order_GetDetails
(
	@OrderID int
)
AS

SELECT
	OrderID,
	Products.ProductName,
	[Order Details].UnitPrice,
	Quantity,
	Discount
FROM
	[Order Details]
	INNER JOIN Products on
	[Order Details].ProductID = Products.ProductID
WHERE
	OrderID = @OrderID
