<% @Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
                 
            LoadGridData( products )

        End Sub
                  
        Private Sub LoadGridData( _
                            myDataList as System.Web.UI.WebControls.DataList )
                  
           Dim conn as New SqlConnection("Initial Catalog=Northwind;" + _
                                       "Server=(local);UID=sa;PWD=!nt3ns!ty;")
           Dim cmd as New SqlCommand("Exec Products_GetAll ", conn)
    
           conn.Open()
           myDataList.DataSource = cmd.ExecuteReader()
           myDataList.DataBind()
           conn.Close()                 
                    
        End Sub
	</script>
	
</HEAD>
<BODY>

<h1>Product List</h1>
<hr>

<form runat="server" id=form1 name=form1>

<asp:DataList id="products" RepeatColumns="3" 
        AlternatingItemStyle-backcolor="#DDDDDD"
        runat="server">
    <ItemTemplate>
        <table border="0" width="300">
          <tr>
              <td width="25">
                  &nbsp
              </td>
              <td width="72" valign="middle" align="right">
                <a href='productdetails.aspx?productID=<%# DataBinder.Eval(Container.DataItem, "ProductID") %>'>
                    <img src='/ADO24HOURS<%# DataBinder.Eval(Container.DataItem, "ImagePath") %>' width="72" height="72" border="0">
                </a>
              </td>
              <td width="150" valign="middle">
                <a href='ProductDetails.aspx?productID=<%# trim(DataBinder.Eval(Container.DataItem, "ProductID")) %>'>
                    <%# DataBinder.Eval(Container.DataItem, "ProductName") %></a><br>                    
                <b>Price: </b>
                    <%# DataBinder.Eval(Container.DataItem, "UnitPrice", "{0:c}") %><br>
                <b>Units In Stock: </b>
                    <%# DataBinder.Eval(Container.DataItem, "UnitsInStock") %>                    
                <br>
                </a>
              </td>
            </tr>
        </table>
    </ItemTemplate>
</asp:DataList>

</form>
<hr>

</BODY>
</HTML>
