<% @Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
                  
            LoadDataGrid(orders)
                   
        End Sub
                  
        Private Sub LoadDataGrid( _
                         myDataGrid as System.Web.UI.WebControls.DataGrid)
                  
           Dim conn as New SqlConnection("Initial Catalog=Northwind;" + _
                                       "Server=(local);UID=sa;PWD=!nt3ns!ty;")
           Dim cmd as New SqlCommand("SELECT OrderID, " + _
                                     "CustomerID, " + _
                                     "OrderDate, " + _
                                     "ShipName " + _
                                     "FROM Orders", conn)
                     
           Dim adapter as New SqlDataAdapter(cmd)
           dim dsOrders as New DataSet()
           
           adapter.Fill(dsOrders)
           
           conn.Open()
           myDataGrid.DataSource = dsOrders
           myDataGrid.DataBind()  
           conn.Close()    
                    
        End Sub
        
        Private Sub GetPage(src as Object, e as DataGridPageChangedEventArgs)
        
            src.CurrentPageIndex = e.NewPageIndex
            LoadDataGrid(src)
        
        End Sub
	</script>
	
</HEAD>
<BODY>

<h1>Paging With the DataGrid</h1>
<hr>

<form runat="server" id=form1 name=form1>
    <asp:DataGrid id="orders" width="90%" BorderColor="SaddleBrown" BackColor="PapayaWhip"
                  GridLines="Vertical" cellpadding="4" cellspacing="0" 
                  Font-Name="Verdana" Font-Size="8pt" ShowFooter="true" 
                  AutoGenerateColumns="false" 
                  AllowPaging="true"
                  PagerStyle-Mode="NextPrev"
                  PagerStyle-PrevPageText="::Previous Page"
                  PagerStyle-NextPageText="Next Page::"
                  PagerStyle-Visible="true"
                  PageSize="10"
                  OnPageIndexChanged="GetPage"
                  runat="server">
        <Columns>
            <asp:BoundColumn HeaderText="Order ID" DataField="OrderID" />
            <asp:BoundColumn HeaderText="Customer ID" DataField="CustomerID" />
            <asp:BoundColumn HeaderText="ShipTo Name" DataField="ShipName" />
            <asp:BoundColumn HeaderText="Order Date" DataField="OrderDate" DataFormatString="{0:d}" />
            <asp:HyperLinkColumn Text="Show Order Details" 
                   DataNavigateUrlField="OrderID" 
                   DataNavigateUrlFormatString="orderdetails.aspx?OrderID={0}" />
        </Columns>
    </asp:DataGrid>
</form>
<hr>

</BODY>
</HTML>
