Imports System

namespace HowTo.ADONET24.Samples

public class TryCatch
  public shared sub Main()
    Dim myTryCatch as TryCatch
    myTryCatch = new TryCatch()
    myTryCatch.Run()
  end sub

  public sub Run()
    Dim a As Integer = 100
    Dim b As Integer = 0

    try
      Console.WriteLine("*** TRY BLOCK - WE WILL DO A DIVISION BY ZERO ***")
      a /= b    ' Divide by zero... arithmetic error

    Catch e As Exception When b = 0  
      Console.WriteLine("*** CATCH BLOCK - ERROR - WE WILL HANDLE THIS OURSELVES ***")
      Console.WriteLine(e.ToString())

    Finally
      Console.WriteLine("*** FINALLY BLOCK - ALWAYS EXECUTED ***")

    end try
    Console.WriteLine()
    Console.WriteLine("*** NOW, DO A DIVISION BY ZERO AGAIN WITHOUT HANDLING IT ***")
    a /= b    ' Divide by zero... arithmetic error

  end sub
end class

end namespace