/*
  This stored procedure adds a new record
  to the employees table  
*/

CREATE PROCEDURE Employee_Add 
(
	@LastName nvarchar(20),
	@FirstName nvarchar(10),
	@Title nvarchar(30),
	@BirthDate datetime,
	@HireDate datetime,
	@Address nvarchar(60),
	@City nvarchar(15),
	@PostalCode nvarchar(10),
	@retval int OUTPUT	
)

AS

INSERT INTO Employees
(
	LastName,
	FirstName,
	Title,
	BirthDate,
	HireDate,
	Address,
	City,
	PostalCode	
)
VALUES
(
	@LastName,
	@FirstName,
	@Title,
	@BirthDate,
	@HireDate,
	@Address,
	@City,
	@PostalCode	
)

SELECT @retval = @@IDENTITY
