<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
          
          If IsPostBack then
            'Create and Open Connection 
            Dim conn as SqlConnection = new SqlConnection("Data Source=" + _
                        "localhost;Initial Catalog=northwind;UID=sa;PWD=;")
                                        
            'Create Command
            Dim cmd as SqlCommand = new SqlCommand("Employee_Add", conn)
            cmd.CommandType = CommandType.StoredProcedure

            Dim pLastName As SqlParameter = New SqlParameter("@LastName", _
                                                       SqlDbType.NVarChar, 20)
            pLastName.Value = Request("txtLastName")
            cmd.Parameters.Add(pLastName)
            
            Dim pFirstName As SqlParameter = New SqlParameter("@FirstName", _
                                                       SqlDbType.NVarChar, 10)
            pFirstName.Value = Request("txtFirstName")
            cmd.Parameters.Add(pFirstName)            

            Dim pTitle As SqlParameter = New SqlParameter("@Title", _
                                                       SqlDbType.NVarChar, 30)
            pTitle.Value = Request("txtTitle")
            cmd.Parameters.Add(pTitle)    
            
            Dim pBirthDate As SqlParameter = New SqlParameter("@BirthDate", 
                                                        SqlDbType.DateTime, 8)
            pBirthDate.Value = Request("txtBirthDate")
            cmd.Parameters.Add(pBirthDate)    
            
            Dim pHireDate As SqlParameter = New SqlParameter("@HireDate", _
                                                        SqlDbType.DateTime, 8)
            pHireDate.Value = Request("txtHireDate")
            cmd.Parameters.Add(pHireDate)   
             
            Dim pAddress As SqlParameter = New SqlParameter("@Address", _
                                                       SqlDbType.NVarChar, 60)
            pAddress.Value = Request("txtAddress")
            cmd.Parameters.Add(pAddress)    
            
            Dim pCity As SqlParameter = New SqlParameter("@City", _
                                                       SqlDbType.NVarChar, 15)
            pCity.Value = Request("txtCity")
            cmd.Parameters.Add(pCity)  
                  
            Dim pPostalCode As SqlParameter = New SqlParameter("@PostalCode", 
                                                       SqlDbType.NVarChar, 10)
            pPostalCode.Value = Request("txtPostalCode")
            cmd.Parameters.Add(pPostalCode)   
            
            Dim pRetval As SqlParameter = New SqlParameter("@retval", _
                                                             SqlDbType.Int, 4)
            pRetval.Direction = ParameterDirection.Output
            cmd.Parameters.Add(pRetval)   

            conn.Open()
            cmd.ExecuteNonQuery()
            conn.Close()
            
            lblStatus.Text = "Employee added with EmployeeID # " + _
                              pRetval.Value.ToString()
          End If                    
            
        End Sub
        
	</script>
	
</HEAD>
<BODY>

<h1>Add a New Employee to the Northwind Database</h1>
<hr>

<form runat="server" id=form1 name=form1>
  <asp:label id=lblStatus runat="server" />
  <table>
    <tr>
        <td>First Name:</td>
        <td><asp:textbox id="txtFirstName" runat="server" /></td>
    </tr>
    <tr>
        <td>Last Name:</td>
        <td><asp:textbox id="txtLastName" runat="server" /></td>
    </tr>
    <tr>
        <td>Title:</td>
        <td><asp:textbox id="txtTitle" runat="server" /></td>
    </tr>
    <tr>
        <td>Birth Date:</td>
        <td><asp:textbox id="txtBirthDate" runat="server" /></td>
    </tr>
    <tr>
        <td>Hire Date:</td>
        <td><asp:textbox id="txtHireDate" runat="server" /></td>
    </tr>
    <tr>
        <td>Address:</td>
        <td><asp:textbox id="txtAddress" runat="server" /></td>
    </tr>
    <tr>
        <td>City:</td>
        <td><asp:textbox id="txtCity" runat="server" /></td>
    </tr>
    <tr>
        <td>Postal Code:</td>
        <td><asp:textbox id="txtPostalCode" runat="server" /></td>
    </tr>
 </table>
 
 <input type="submit" value="add new employee">  
   
</form>
<hr>

</BODY>
</HTML>
