Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.VisualBasic

namespace HowTo.ADONET24.Samples

public class conpool

  public shared sub Main()
    Dim myconpool as conpool = new conpool()
    myconpool.Run()
  end sub

  public sub Run()
    try
      
      Dim connString1 as String

      connString1 = "server=C81124-E\DBARCH01;Trusted_Connection=yes;database=northwind;" & _
                   "connection reset=false;" & _
                   "connection lifetime=0;" & _
                   "enlist=true;" & _
                   "min pool size=1;" & _
                   "max pool size=50"

      Dim connString3 as String
      connString3 = "server=C81124-E\DBARCH01;Trusted_Connection=yes;database=pubs;" & _
                   "connection reset=false;" & _
                   "connection lifetime=0;" & _
                   "enlist=true;" & _
                   "min pool size=10;" & _
                   "max pool size=50"

      Dim myConnection1 as SqlConnection = new SqlConnection(connString1)

      Dim myConnection2 as SqlConnection = new SqlConnection(connString1)

      Dim myConnection3 as SqlConnection = new SqlConnection(connString1)

      Dim myConnection5 as SqlConnection = new SqlConnection(connString3)

      Dim CustomerAdapter1 As SqlDataAdapter = New SqlDataAdapter("SELECT CustomerID,          CompanyName, ContactName FROM Customers WHERE CustomerID like 'B%' ORDER BY           	 	 CustomerID", myconnection1)

      Dim CustomerAdapter2 As SqlDataAdapter = New SqlDataAdapter("SELECT CustomerID,         CompanyName, ContactName FROM Customers WHERE CustomerID like 'D%' ORDER BY           	 	 CustomerID", myconnection2)

      Dim CustomerAdapter3 As SqlDataAdapter = New SqlDataAdapter("SELECT CustomerID,         CompanyName, ContactName FROM Customers WHERE CustomerID >= 'T' ORDER BY           	 	 CustomerID", myconnection3)

      Dim EmployeeAdapter1 As SqlDataAdapter = New SqlDataAdapter("SELECT Emp_ID,LName FROM Employee WHERE Lname like 'B%' ORDER BY LName", myconnection5)


'********************** establish first connection pool **********************
      Console.WriteLine ("Opening two connections in pool A")
      myConnection1.Open()
      myConnection2.Open()

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

      Dim CustomerDataSet1 As DataSet = New DataSet()
      Console.WriteLine ("Execise the connection with a database query using pool A")
      CustomerAdapter1.Fill(CustomerDataSet1, "Customers")

      Dim CustRow1 As DataRow
      Console.Writeline ("Show contents of DataSet just read")
      For each CustRow1 in CustomerDataSet1.Tables("Customers").Rows
          Console.Writeline("Customer Contacts Selected: " + CustRow1("ContactName").ToString())
      Next

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

      Dim CustomerDataSet2 As DataSet = New DataSet()
      Console.WriteLine ("Execise the connection with a different database query using pool A")
      CustomerAdapter2.Fill(CustomerDataSet2, "Customers")

      Dim CustRow2 As DataRow
      Console.Writeline ("Show contents of DataSet just read")
      For each CustRow2 in CustomerDataSet2.Tables("Customers").Rows
          Console.Writeline("Customer Contacts Selected: " + CustRow2("ContactName").ToString())
      Next

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

      Console.WriteLine ("Now Returning both of the connections to pool A")
      myConnection1.Close()
      myConnection2.Close()

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

      Console.WriteLine ("Open another connection from the same pool A")
      myConnection3.Open()

      Dim CustomerDataSet3 As DataSet = New DataSet()
      Console.WriteLine ("Execise the connection with another database query using pool A")
      CustomerAdapter3.Fill(CustomerDataSet3, "Customers")

      Dim CustRow3 As DataRow
      Console.Writeline ("Show contents of DataSet just read")
      For each CustRow3 in CustomerDataSet3.Tables("Customers").Rows
          Console.Writeline("Customer Contacts Selected: " + CustRow3("ContactName").ToString())
      Next

      Console.WriteLine ("Returing this connection to pool A")
      myConnection1.Close()

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

'********************** establish a separate connection pool **********************

      Console.WriteLine ("Opening a new connection in pool B")
      myConnection5.Open()

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

      Dim EmployeeDataSet1 As DataSet = New DataSet()
      Console.WriteLine ("Execise the connection with a database query using pool B")
      EmployeeAdapter1.Fill(EmployeeDataSet1, "Employee")

      Dim EmpRow1 As DataRow
      Console.Writeline ("Show contents of DataSet just read")
      For each EmpRow1 in EmployeeDataSet1.Tables("Employee").Rows
          Console.Writeline("Employees Selected: " + EmpRow1("LName").ToString())
      Next

      Console.WriteLine ("Hit Enter key to continue")
      Console.ReadLine ()

      Console.WriteLine ("Returing this connection to pool B")
      myConnection5.Close()

    catch e as Exception
      ' Display the error.
      Console.WriteLine(e.ToString())
    end try

  end sub
end class

end namespace
