Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.VisualBasic

namespace HowTo.ADONET24.Samples

Public Class NormalUpd
  Public Shared Sub Main()
    Dim dbConn As SqlConnection = New SqlConnection("Data Source=C81124-E\DBARCH01;Integrated Security=SSPI;Initial Catalog=northwind")

    Dim CustomerAdapter As SqlDataAdapter = New SqlDataAdapter("SELECT CustomerID, ContactName FROM Customers", dbConn)

  CustomerAdapter.UpdateCommand=New SqlCommand("UPDATE Customers SET ContactName=@ContactName " & _
"WHERE CustomerID = @oldCustomerID", dbConn)

  CustomerAdapter.UpdateCommand.Parameters.Add("@ContactName", SqlDbType.NVarChar, 30, "ContactName")

  Dim OldParms As SqlParameter
  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldCustomerID", SqlDbType.NChar, 5, "CustomerID")
  OldParms.SourceVersion = DataRowVersion.Original

  Dim CustomerDataSet As DataSet = New DataSet()

  Console.Writeline ("Go get some customer data - Fill")
  CustomerAdapter.Fill(CustomerDataSet, "Customers")

  Console.Writeline ("Update the first ContactName in DataSet")
  Dim UpdtRow As DataRow = CustomerDataSet.Tables("Customers").Rows(0)
  UpdtRow("ContactName")= "Donald Renato"

  Console.Writeline ("Update the Database")
  CustomerAdapter.Update(CustomerDataSet, "Customers")

  Dim CustRow As DataRow

  Console.Writeline ("Show contents of DataSet")
  For each CustRow in CustomerDataSet.Tables("Customers").Rows
      Console.Writeline("Customer Contacts Selected: " + CustRow("ContactName").ToString())
  Next

 End Sub
End Class
End namespace