CREATE PROCEDURE Product_Update 
(
	@ProductID int,
	@ProductName nvarchar(40),
	@QuantityPerUnit nvarchar(20),
	@UnitPrice money,
	@UnitsInStock smallint,
	@ImagePath varchar(256),
	@Discontinued bit,
	@RowsAffected int OUTPUT
)
AS

UPDATE 
	Products
SET
	ProductName = @ProductName,
	QuantityPerUnit = @QuantityPerUnit,
	UnitPrice = @UnitPrice,
	UnitsInStock = @UnitsInStock,
	ImagePath = @ImagePath,
	Discontinued = @Discontinued
WHERE
	ProductID = @ProductID