<% @Page Debug="true" EnableViewState="false" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
      Sub Page_Load(Source as Object, E as EventArgs)
             
         if IsPostBack and Page.IsValid then
         
            Dim conn as new SqlConnection( _
                 "Initial Catalog=Northwind;Server=(local);UID=sa;PWD=;")
            
            'Build the SQL string
            'Use StringBuilder object for better performance
            Dim strBuilder as new StringBuilder()
            
            strBuilder.Append("INSERT INTO Employees ")
            strBuilder.Append("(FirstName, LastName, Title, HireDate) VALUES(")
            strBuilder.Append("'" + Request("txtFirstName") + "',")
            strBuilder.Append("'" + Request("txtLastName") + "',")
            strBuilder.Append("'" + Request("txtTitle") + "',")
            strBuilder.Append("'" + Request("txtDateHired") + "')")
            
            Dim sSQL as string = strBuilder.ToString()
            
            Dim cmd as SqlCommand = new SqlCommand(sSQL, conn)
           
            conn.Open()
            cmd.ExecuteNonQuery()
            conn.Close()
            
            txtFirstName.Text = ""
            txtLastName.Text = ""
            txtTitle.Text = ""
            txtDateHired.Text = ""
         end if
         
         LoadData()
         
      End Sub
      
      private Sub LoadData() 
      
         Dim conn as SqlConnection = new SqlConnection( _
               "Initial Catalog=Northwind;Server=(local);UID=sa;PWD=;")
         Dim cmd as SqlCommand = new SqlCommand( _
           "SELECT FirstName, LastName, Title, HireDate FROM Employees", conn)
         
         Dim adapt as SqlDataAdapter = new SqlDataAdapter(cmd)
         Dim dsEmployees as DataSet = new DataSet()
         
         conn.Open()
         adapt.Fill(dsEmployees, "Employees")
         conn.Close()
         
         employees.DataSource = dsEmployees
         employees.DataBind()
         
      End Sub
	</script>
	
</HEAD>
<BODY>

<h1>Adding a Record to the Database</h1>
<hr>
<asp:Label id=msg runat=server />
<form runat="server" id=form1 name=form1>
   <asp:DataGrid id="employees" runat="server"></asp:DataGrid>
   <br>
   Add a new record:<br>
   <table>
   <tr>
       <td>First Name: </td>
       <td><asp:textbox runat="server" 
                 id="txtFirstName" EnableViewState="false">
           </asp:textbox></td>
       <td><asp:RequiredFieldValidator runat="server"
              ControlToValidate="txtFirstName"
              InitialValue=""
              ErrorMessage="You must enter the first name."/></td>
   </tr>
   <tr>
       <td>Last Name: </td> 
       <td><asp:textbox runat="server" id="txtLastName"></asp:textbox></td>
       <td><asp:RequiredFieldValidator runat="server"
              ControlToValidate="txtLastName"
              InitialValue=""
              ErrorMessage="You must enter the last name."/></td>
   </tr>
   <tr>
       <td>Title: </td> 
       <td><asp:textbox runat="server" id="txtTitle"></asp:textbox></td>
   </tr>
      <tr>
       <td>Date Hired: </td> 
       <td><asp:textbox runat="server" id="txtDateHired"></asp:textbox></td>
   </tr>
   </table>
   <input type="submit" id=submit1 name=submit1>
</form>
<hr>

</BODY>
</HTML>
